import haxegon.*;
import std.*;

#if js
import js.Browser;
#end

class Main {

	var EXPORTMODE = false;
	var charWidth =5;

	var mainButton = 0x0000ff;
	var mainHighlight = 0x5555ff;
	var mainHighlightish = 0x8888ff;
	var mainHighlighter = 0xaaaaff;

	var panelCol = 0x000088;
	var panelColLight = 0x0000aa;
	var backgroundCol = Col.NIGHTBLUE;
	var textCol = 0xeeeeee;
	var darkText=0x888888;

	var playing=false;
	var playTick=0;

	var instCols = [
	  [0x880088,0xff55ff],
	  [0x888800,0xffff55],
	  [0x880000,0xff5555],
	  [0x008888,0x55ffff],
	  [0x008800,0x55ff55]
	];

	var blackNotes = [false,false,true,false,true,false,false,true,false,true,false,true];

	var notenames=["c#","d","d#","e","f","f#","g","g#","a","a#","b","c"];
	/*
	FILE
	patternLength : [1-16]
	cellDuration : [1..10]
	instruments : 5*int8
	sequences : seqSlotCount*[1..12]
	notes : seqCount*
	[ noteCount * ([1..128],[1..16],[1..16],[] )]
	*/
	// a note is [note, length, onset, amplitude]


	var dat = {
	  patternLength:16,
	  cellDuration:3,
	  instruments:[57803926,67910236,85155178,1,14620627],
	  sequences:[0],
	  notes:[
	    [[],[],[],[],[]]
	  ]
	};

	var B62 = [ "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z", "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
	           "à","á","â","ä","æ","ã","å","ā","è","é"        
	          ];

	/*
	var dat = {
	patternLength:16,
	cellDuration:3,
	instruments:[1,2,61,62,63],
	sequences:[0],
	notes:[]};*/


	var pressedDownOnCanvas=false;
	var oldAddX=-1;
	var oldAddY=-1;
	function stripWhitespace(s){
		return StringTools.trim(s);
	}
	function loadDat(s){
	  s = stripWhitespace(s);
	  s = unmakeRLE(s);
	  var arr = [];
	  for(ci in 0...s.length){
	    var c = s.charAt(ci);
	    arr.push(B62.indexOf(c));
	  }
	  dat = {
		  patternLength:16,
		  cellDuration:3,
		  instruments:[57803926,67910236,85155178,1,14620627],
		  sequences:[0],
		  notes:[
		    [[],[],[],[],[]]
		  ]
		};

	  var i=0;
	  dat.patternLength=arr[i];

	  i++;
	  dat.cellDuration=arr[i];

	  dat.instruments=[];
	  for (j in 0...5){
	    var n=0;
	    var p = 1;
	    for (k in 0...5){
	      i++;
	      n = n + p*arr[i];      
	      p=p*62;
	    }
	    dat.instruments.push(n);
	  }


	  var outputAr=[];

	  i++;
	  var sequenceCount=arr[i];
	  outputAr.push(arr[i]);
	  dat.notes=[];
	  for (j in 0...sequenceCount){       
	    var sequence  = [[],[],[],[],[]];
	    for (m in 0...5){
	      i++;      
	      var noteCount =arr[i];
	      outputAr.push(arr[i]);
	      var noteSeq =sequence[m];
	      for(k in 0...noteCount){
	        i++;
	        var v1 = arr[i];
	        outputAr.push(arr[i]);
	        i++;
	        var v2 = arr[i];
	        outputAr.push(arr[i]);
	        var v = v1+62*v2;

	        noteSeq.push([v]);  
	      }
	      for (l in 1...4){
	        for(m in 0...noteCount){
	          i++;
	          noteSeq[m].push(arr[i]);
	          outputAr.push(arr[i]);
	        }
	      }
	    }
	    dat.notes.push(sequence);
	  }
	}

	function saveDat():String{  
	  var intArray =[];
	  intArray.push(dat.patternLength);
	  intArray.push(dat.cellDuration);
	  for ( i in 0...5){
	  	var n = dat.instruments[i];
	    for ( j in 0...5){
	      var p1 = Math.pow(62,j);
	      var v = Std.int(n/p1)%62;
	      intArray.push(v); 
	    }
	  }

	  var outputAr =[];
	  intArray.push(dat.notes.length);  
	  outputAr.push(intArray[intArray.length-1]);
	  for(r in dat.notes){
	    for (i in 0...5){
	      var instNotes = r[i];
	      intArray.push(instNotes.length);
	      for (n in instNotes){
	        intArray.push(n[0]%62);
	        intArray.push(Convert.toint(n[0]/62)%62);    
	      }
	      for (j in 1...4){
	        for (n in instNotes){            
	          intArray.push(n[j]);
	        }
	      }
	    }
	  }

	  var result:String="";
	  for( n in intArray){
	    result = result+B62[n];    
	  }
	  result = makeRLE(result);
	  return result;
	}

	function makeRLE(s:String):String {
	  var result ="";
	  var lastChar=s.charAt(0);
	  var lastCharCount=1;
	  for (i in 1...s.length){
	    var c = s.charAt(i);
	    if (c == lastChar){
	      lastCharCount++; 
	    } else {
	      if (lastCharCount>1){
	        result = result+lastCharCount;
	      }
	      result = result + lastChar;
	      lastChar = c;
	      lastCharCount = 1;

	    }
	  }

	  if (lastCharCount>1){
	    result = result+lastCharCount;
	  }
	  result = result + lastChar;

	  return result;
	}

	function unmakeRLE(s):String{
	  var result ="";
	  var lastInt=0;
	  var i = 0;
	  while(i<s.length){
	    var c = s.charAt(i);
	    while (c=="0"||c=="1"||c=="2"||c=="3"||c=="4"||c=="5"||c=="6"||c=="7"||c=="8"||c=="9"){
	      lastInt=lastInt*10+Convert.toint(c);
	      i++;
	      c=s.charAt(i);
	    }
	    if (lastInt==0){
	      lastInt=1;
	    }

	    for (i in 0...lastInt){
	      result = result +c;    
	    }
	    i++;
	    c=s.charAt(i);
	    lastInt=0;
	  }

	  return result;
	}

	var channelOrder = [0,1,2,3,4];           

	var selectedInst =0;
	var noteLength =3;
	var lastl = 3;//noteLength

	var maxVol =9;
	var noteVol =9;//maxVol
	var selectedSequence =0;
	var bottomNote=59;

	var backups=[];
	function MakeBackupCopy(){
	  var oldDat = saveDat();
	  if (backups.length>0&&oldDat==backups[backups.length-1]){
	    return;
	  }
	  backups.push(oldDat);
	}

	function DoUndo(){
	  if (backups.length==0){ return; }
	  playing=false;
	  var backup=backups.pop();
	  loadDat(backup);
	  if (selectedSequence>dat.notes.length){
	    selectedSequence=dat.notes.length-1;
	  }
	}

	function drawButton(text,x,y,textcolor,color,colorhover,returnhoverstatus=false) {
	  var width=35;
	  var w = Math.round(Text.width(text));
	  if (w+8>=width){
	  	width=w+8;
	  }
	  var height=9;
	  var dx = Mouse.x-x;
	  var dy = Mouse.y-y;

	  var collide = !(dx<0||dx>=width||dy<0||dy>=height);

	  var click = collide && Mouse.leftclick();

	  if (collide&& !click){
	    color=colorhover;
	  }
	  Gfx.fillbox(x,y,width,height,color);
	  Text.display(x+4, y+2, text, textcolor);
	  
	  if (returnhoverstatus==true){
	  	click=collide;
	  }
	  return click;
	}


	function collideBox(x,y,w,h) {
	  var dx = Mouse.x-x;
	  var dy = Mouse.y-y;


	  var collide = !(dx<0||dx>=w||dy<0||dy>=h);

	  if (collide==false){    
	    return 0;    
	  }
	  if (Mouse.leftclick()){
	    return 2;
	  }
	  if (Mouse.rightclick()){
	    return 3;
	  }
	  return 1;
	}

	var scrollt=0;
	var scrollInterval=12;

	function getNum(){
	  if (Input.justpressed(Key.ONE)){
	    return 1;
	  }
	  if (Input.justpressed(Key.TWO)){
	    return 2;
	  }
	  if (Input.justpressed(Key.THREE)){
	    return 3;
	  }
	  if (Input.justpressed(Key.FOUR)){
	    return 4;
	  }
	  if (Input.justpressed(Key.FIVE)){
	    return 5;
	  }
	  if (Input.justpressed(Key.SIX)){
	    return 6;
	  }
	  if (Input.justpressed(Key.SEVEN)){
	    return 7;
	  }
	  if (Input.justpressed(Key.EIGHT)){
	    return 8;
	  }
	  if (Input.justpressed(Key.NINE)){
	    return 9;
	  }
	  if (Input.justpressed(Key.ZERO)){
	    return 0;
	  }
	  return -1;
	}

	function startPlay() {
	  playing=true;
	  playTick=selectedSequence*dat.patternLength*dat.cellDuration -1;
	}

	function stopPlay(){
	  playing=false;
	}

	function PushNewSequence(){
	  MakeBackupCopy();
	  var minNotFound=0;
	  var changed=true;
	  dat.notes.push([[],[],[],[],[]]);
	}


	function GamePrompt(description:String,text:String):String{
		#if js
		return Browser.window.prompt(description,text);
		#end
	}

	function MusicPlayNote(a:Int,b:Float,c:Float,d:Float){
		#if js
		untyped playNote(a,b,c,d/4);
		#end
	}

	function bloop(){
		Music.playsound("blip");
		//MusicPlayNote(85155178,220,1.0,0.5);
	}

	var lCounter=0;
	var rCounter=0;
	var plusCounter=0;
	var minusCounter=0;

	var copyBuffer=null;


	function DecreasePatternLength(){
		if (dat.patternLength==1){
			return;
		}
	  dat.patternLength--;
	  
	  for (sequence in dat.notes){
	    for (channel in sequence){
	      for (i in 1-channel.length...1){
	        // a note is [note, length, onset, amplitude]
	        var n = channel[-i];
	        if (n[2]==dat.patternLength){
	          channel.splice(-i,1);
	        }
	        if (n[2]+n[1]-1==dat.patternLength){
	          n[1]--;
	        }
	      }
	    }
	  }
	}   

	function DoCopy(){
	  var toCopy=dat.notes[selectedSequence];
	  copyBuffer=[];
	  for (a in toCopy){
	    var r1=[];
	    for (b in a){
	      var r2=[];
	      for (c in b){
	        r2.push(c);   
	      }
	      r1.push(r2);
	    }
	    copyBuffer.push(r1);
	  }
	}

	function DoPaste(){
	  if (copyBuffer==null){
	    return;
	  }
	  dat.notes[selectedSequence]=copyBuffer;
	  DoCopy();
	}


	function occasional(){
        return 0.2 > Random.random();
    };

	function GenerateRandom(){
	  dat = {
	    patternLength:Random.int(3,16),
	    cellDuration:Random.int(1,10),
	    instruments:[Random.int(0,99999999),Random.int(0,99999999),Random.int(0,99999999),Random.int(0,99999999),Random.int(0,99999999)],
	    sequences:[0],
	    notes:[],
	  };
	  var sequenceCount = 11;
	  var noteDensity=Random.float(0.1,0.5);
	  var preferredLengths=[];
	  for (i in 0...5){
	    preferredLengths.push(Random.int(1,dat.patternLength));
	  }
	  for (i in 0...sequenceCount){
	    var sequence=[];
	    for (j in 0...5){
	      var channel=[];
	      if (!occasional()) {
	        var maxOnset = dat.patternLength-preferredLengths[j];
	        for (k in 0...(maxOnset)){
	          var r = Random.float(0,1);
	          if (k%4==0){
	            r=r*r;
	          }
	          if(r<noteDensity){
	            // a note is [note, length, onset, amplitude]
	            channel.push([Random.int(1,120),preferredLengths[j],Random.int(1,maxOnset),Random.int(1,7)]);
	          }     
	        }
	      }
	      sequence.push(channel);
	    }
	    dat.notes.push(sequence);
	  }
	  for (i in 0...sequenceCount){
	    selectedSequence=i;
	    DoCopy();
	    selectedSequence=Random.int(0,dat.notes.length);
	    DoPaste();
	  }
	}

	var helpmode=false;

	var overLink1:Int = 0;
	var overLink2:Int = 0;

	function doHelp(){
	  Gfx.clearscreen(backgroundCol);
	  if (Input.justpressed(Key.SPACE)||Input.justpressed(Key.H)||Input.justpressed(Key.ESCAPE)||Mouse.leftclick()){
	    helpmode=false;
	  }
	  Text.size=2.5;
	  var titleTop=20;
	  Text.display(Text.CENTER,10,"tinybox");
	  Text.size=1;


	 var linkButton = 0x880088;
	 var linkHighlight = 0x885588;

	if (drawButton("increpare.com",3,12,textCol,linkButton,linkHighlight,true)){
		overLink1 = 5;
	}


	var rposx:Int = Gfx.screenwidth-3-Math.round(Text.width("  patreon   "))-8;
	if (drawButton("  patreon   ",rposx,12,textCol,linkButton,linkHighlight,true)){
		overLink2 = 5;
	}

	  var i=0;
	  var textTop=titleTop+15;
	  Text.display(3,textTop+13*(i++),"Shortcuts:");
	  Text.display(3,textTop+13*(i++),"~ Arrow keys or wsad,to scroll/set note length.");
	  Text.display(3,textTop+13*(i++),"~ +/- or q and e to control volume.");
	  Text.display(3,textTop+13*(i++),"~ Right click on instruments to randomize,");
	  Text.display(3,textTop+13*(i++),"~ Or press numbers when hovering to enter.");
	  Text.display(3,textTop+13*(i++),"~ You can press c/v to copy/paste sequences.");
	  Text.display(3,textTop+13*(i++),"~ Right click notes/sequences to remove.");
	  Text.display(3,textTop+13*(i++),"~ Z to undo.");
	}


	function doExportPanel(){
	  Gfx.clearscreen(backgroundCol);
	  if (Input.justpressed(Key.SPACE)||Input.justpressed(Key.H)||Input.justpressed(Key.ESCAPE)||Mouse.leftclick()){
	    helpmode=false;
	  }
	  Text.size=2.5;
	  var titleTop=20;

	  var pc = Math.floor( (100*playTick)/(dat.notes.length*dat.patternLength*dat.cellDuration) );
	  Text.display(Text.CENTER,50,"EXPORTING");
	  Text.display(Text.CENTER,70,pc+"%");
	  Text.size=1;

	}


	function startExport(){
		selectedSequence=0;
		EXPORTMODE=true;

		#if js
		untyped startRecording();
		#end

		startPlay();
	}


	function audioUpdate(){
		if (!playing){
			return;
		}
		


		playTick++;    
	    var pieceLengthInTicks = dat.notes.length*dat.patternLength*dat.cellDuration;

	    if (EXPORTMODE){
	    	if (playTick==pieceLengthInTicks){
	    		stopPlay();

				#if js
				untyped stopRecording();
				#end

				EXPORTMODE=false;
				return;
	    	}
	    }
	    playTick = playTick%pieceLengthInTicks;
	    
	    var globalCell = Convert.toint(playTick/dat.cellDuration);
	    var playPattern = Convert.toint(globalCell/dat.patternLength);
	    selectedSequence=playPattern;
	    var patternProgress = globalCell-dat.patternLength*playPattern;

	    if (playTick%dat.cellDuration==0){
	      TryPlayNote(patternProgress);
	    }

	}


	var bg = 
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000"+"\n"+
"00000000000000000";

var screens = [ 
//3
"WWWWWWWWWWWWWWWWW"+"\n"+
"WBBTWFFFWCCFFFBBW"+"\n"+
"WBBOFFFFFFFFFPBBW"+"\n"+
"WFFFWFFFWWWWWWWWW"+"\n"+
"WWWWWWWFWFFFCFCCW"+"\n"+
"WOFFFFFFFFFFTFFCW"+"\n"+
"WBBFFFWFWTVOFFFFW"+"\n"+
"WWWWWWWXWWWWWWWWW",

//3
"CITYCITYCITYCITYC"+"\n"+
"ITWWWWWWWWWWWWWCI"+"\n"+
"TYWTFWTTOFFFOKWIT"+"\n"+
"YCWOFWTTFFFFFKWTI"+"\n"+
"CIWFFWOFFFFBBBWIT"+"\n"+
"ITWFFFFFPFFBBBWCI"+"\n"+
"TYWWWWWXWWWWWWWIT"+"\n"+
"YCITYCITYCITYCITY",

//4
"WWWWWWWWWWWWWWWWW"+"\n"+
"WBFPWFFFFFFFFFFFW"+"\n"+
"WBFFWFFCFCFCFFFFW"+"\n"+
"WWOWWFFFFFFFFFKTW"+"\n"+
"WFFFWFFFFOFFFFQTW"+"\n"+
"WFOFFFFCFCFCTFFFW"+"\n"+
"WFFFWOFFFFFFFFFFW"+"\n"+
"WWWWWWWWWWWWWWWWW",

//0
"WWWWWWWWWWWWWWWWW"+"\n"+
"WBFFWFFFFFFFFFFFW"+"\n"+
"WBFFWFFCFCFCFFFFW"+"\n"+
"WWFWWFFFFFFFFPKTW"+"\n"+
"WFFFWFFFFFFFFFQTW"+"\n"+
"WFFFFFFCFCFCTFFFW"+"\n"+
"WFFFWFFFFFFFFFFFW"+"\n"+
"WWWWWWWWWWWWWWWWW",

//3
"WWWWWWWWWWWWWWWWW"+"\n"+
"WBBTWFFFWCCFOFBBW"+"\n"+
"WBBFFFFFFFFFFFBBW"+"\n"+
"WFFFWFFFWWWWWWWWW"+"\n"+
"WWWWWWWFWFFFCOCCW"+"\n"+
"WOFFFFFFFFFFTFFCW"+"\n"+
"WBBFFFWPWTVFFFOFW"+"\n"+
"WWWWWWWXWWWWWWWWW",

//4
"CITYCITYCITYCITYC"+"\n"+
"ITWWWWWWWWWWWWWCI"+"\n"+
"TYWTFWTTFFFFFKWIT"+"\n"+
"YCWOFWTTOFFFPKWTI"+"\n"+
"CIWFFWOFFFFBBBWIT"+"\n"+
"ITWFFFFFFFOBBBWCI"+"\n"+
"TYWWWWWXWWWWWWWIT"+"\n"+
"YCITYCITYCITYCITY",
];

var theend = 
"theendtheendtheen"+"\n"+
"heendtheendtheend"+"\n"+
"eendtheendtheendt"+"\n"+
"endtheendtheendth"+"\n"+
"ndtheendtheendthe"+"\n"+
"dtheendtheendthee"+"\n"+
"theendtheendtheen"+"\n"+
"heendtheendtheend";

	var exitstate:Bool;

	var exits = ["X","B","K","B","B","X"];
	var state:Int=0;
	var index:Int=0;
	var scr:String=  
"theendtheendtheen"+"\n"+
"heendtheendtheend"+"\n"+
"eendtheendtheendt"+"\n"+
"endtheendtheendth"+"\n"+
"ndtheendtheendthe"+"\n"+
"dtheendtheendthee"+"\n"+
"theendtheendtheen"+"\n"+
"heendtheendtheend";
	var cwidth=4;
	var cheight=7;
	var cols=17;
	var rows = 8;

	function trymove(scr:String,pi:Int,ti:Int):Int{
		var c =  scr.charAt(ti);
		var lvl = Math.round((state-1)/2);
		if (c=="F"){
			return ti;
		} else if (c=="O"){
			showmessage=true;
			return pi;
		} else if (c==exits[lvl] && index==texts[state].length){
			if (lvl<5){
				state++;
				setStage();
			} else {				
				var pi = scr.indexOf("P");
				scr=scr.substring(0,pi)+"F"+scr.substring(pi+1);			
				exitstate=true;
			}
			return pi;
		} else {
			return pi;
		}
	}

	var noisecount=0;
	var noisearray=[];
	function doNoise(){
		for (i in 0...noisecount){
			var ix = noisearray[i];
			var ix_x=ix%Gfx.screenwidth;
			var iy_y=Math.floor(ix/Gfx.screenwidth);
			Gfx.fillbox(ix_x,iy_y,1,1,bgcol);
		}
		for (j in 0...20){
			var rr = Random.int(0,noisecount);
			noisearray[rr]=Random.int(0,Gfx.screenwidth) + Gfx.screenwidth*Random.int(0,Gfx.screenheight);
		}
	}

	var showmessage:Bool=false;

	var schemes:Array<Dynamic> = [
		[
			0x000000,	//bg
			0xffffff,	//fg
			0,	//randomness	
			"house1",				
		],
		[
			0x0000ff,	//bg
			0xffffff,	//fg
			0,	//randomness	
			"quirky",					
		],
		[
			0xffff00,	//bg
			0x000000,	//fg
			5,	//randomness
			"boopy",						
		],
		[
			0xffff00,	//bg
			0x000000,	//fg
			5,	//randomness	
			"",					
		],
		[
			0x000000,	//bg
			0xeeeeee,	//fg
			5,	//randomness	
			"house2",					
		],
		[
			0x0000ff,	//bg
			0xffffff,	//fg
			0,	//randomness
			"STOP"						
		],
	];

	var texts = [
		[
			"DREAMINGS"
		],
		[
			"You're all packed for your big trip?",
			"All the best my big sis!",
			"You'll have a grand time!"		
		],
		[
			"And so I left for a far away city"
		],
		[
			"I'm finally free",
			"I can do whatever I want",
			"I can be whoever I want",
			"Bedtime now though"
		],
		[
			"I dreamed and dreamed",
			"And then I awoke somewhere strange"
		],
		[
			"Princess! come quickly!",
			"Is something wrong princess?",
			"The king needs to speak with you",
			"It's urgent! Hurry!",			
		],
		[
			"I don't like this",
			"I just want to go home",
			"I miss home!",
			"Maybe if I sleep here I will wake up at home"
		],
		[
		],
		[	
			"ZZz..."
		],
		[
			"I missed you so much",
			"I'll never leave again",
			"I wasn't cut out for the city",
			"Go and rest now.  We'll get breakfast tomorrow"
		],
		[
			"What's happening?"
		],
		[
			"...",
			"...",
			"...",
			"..."
		]
	];

	var txt="";
	var bgcol=0x000000;
	var fgcol=0xffffff;
	var exittimer:Int=0;
	var ei=-1;
	var timer:Int=-1;
	function update() {
	  	Gfx.fillbox(0,0,Gfx.screenwidth,Gfx.screenheight,bgcol);

	  	if (state==texts.length-1 && index==texts[state].length){
	  		exitstate=true;
	  	}
	  	if (exitstate){

	  		if (timer % 5==0){
		  		if (ei>=0){
		  			scr=scr.substring(0,ei)+"   "+scr.substring(ei+3);
		  		}
			
				ei = Random.int(0,rows-3) + (rows+1)*Random.int(0,cols);
				var msg = (exittimer%2==0)?"the":"end";
				scr=scr.substring(0,ei)+msg+scr.substring(ei+3);
		  		exittimer++;
			}		
	  		timer++;
			Text.display(1,1,scr,fgcol);
			doNoise();
			return;		
	  	}
		if (state%2==0 || showmessage){
			
			if (Input.justpressed(Key.SPACE)){
				bloop();
				index++;
				showmessage=false;
				if (index>=texts[state].length){					
					if (state%2==0){
						state++;
						setStage();
					} else {
						//level end trigger
					}
				} else {
					txt=texts[state][index]+"\n\npress space to continue";
				}
				return;
			}

			Text.wordwrap=Gfx.screenwidth-2;
			Text.display(1,1,txt,fgcol);
			Text.wordwrap=0;

			doNoise();
			return;
		}
		
		var pi = scr.indexOf("P");
		scr=scr.substring(0,pi)+"F"+scr.substring(pi+1);
		var ti=-1;
		if (Input.justpressed(Key.UP)){
			ti = pi-cols-1;
			pi = trymove(scr,pi,ti);
		}
		if (Input.justpressed(Key.DOWN)){
			ti = pi+cols+1;
			pi = trymove(scr,pi,ti);
		}
		if (Input.justpressed(Key.LEFT)){
			ti = pi-1;
			pi = trymove(scr,pi,ti);
		}
		if (Input.justpressed(Key.RIGHT)){
			ti = pi+1;
			pi = trymove(scr,pi,ti);
		}
		if (showmessage){
			scr=scr.substring(0,ti)+"F"+scr.substring(ti+1);			
		}
		scr=scr.substring(0,pi)+"P"+scr.substring(pi+1);
		Text.display(1,1,scr,fgcol);

		doNoise();
		// for ( i in 0...17){
		// 	for ( j in 0...8){
		// 		Text.display(1+i*cwidth,1+j*cheight,"c");
		// 	}
		// }
	}

	function DoPlayNote(c:Int,n){
	  var notePos = n[2];
	  var pitch = Math.pow(2,(n[0]-61)/12);
	  var noteLength = n[1]*dat.cellDuration/30;
	  MusicPlayNote(dat.instruments[c],pitch,noteLength,n[3]/maxVol);
	}

	function TryPlayNote(x){
	  for (c in 0...5){
	    var channel = dat.notes[selectedSequence][c];  
	    for (n in channel){
	      // var n = channel[nIndex];
	      // a note is [note, length, onset, amplitude]
	      var notePos = n[2];
	      if (notePos==x){  
	        DoPlayNote(c,n);
	      }         
	    }    
	  }
	}  

	function setInstrument(k,play){
	  if (play){
	    MusicPlayNote(dat.instruments[k],1,1,1.0);
	  }
	  selectedInst=k;
	  var kIndex=channelOrder.indexOf(k);
	  channelOrder.splice(kIndex,1);
	  channelOrder.push(k);
	}

	function deleteNote(clickX,clickY){
	  for (n in dat.notes[selectedSequence][selectedInst]){
	    var noteX=n[2];
	    var noteL=n[1];
	    var noteY=n[0];
	    if (clickY==noteY && clickX>=noteX && clickX<(noteX+noteL)){   
	      var arr = dat.notes[selectedSequence][selectedInst];
	      var noteIndex = arr.indexOf(n);
	      arr.splice(noteIndex,1);
	      break;
	    }
	  }
	}


	function blockNote(clickX,clickY){
	  for (n in dat.notes[selectedSequence][selectedInst]){
	    var noteX=n[2];
	    var noteL=n[1];
	    var noteY=n[0];
	    if (clickY==noteY && clickX>=noteX && clickX<(noteX+noteL)){ 
	      if (clickX==noteX){
	        //delete it
	        var arr = dat.notes[selectedSequence][selectedInst];
	        var noteIndex = arr.indexOf(n);
	        arr.splice(noteIndex,1);
	        break;
	      } else {
	        //resize it
	        n[1]=clickX-noteX;
	      }
	    }
	  }
	}

	function setText(s:String){
		txt = s+"\n\npress space to continue";
	}

	function setStage(){			
		index=0;
		setText(texts[state][index]);
		if (state%2==1){		
			var lvl = Math.round((state-1)/2);
 			scr = screens[lvl];
 			bgcol = schemes[lvl][0];
 			fgcol = schemes[lvl][1];
 			noisecount = schemes[lvl][2];
 			var m = schemes[lvl][3];
 			if (m==""){
 			} else if (m=="STOP"){
 				Music.stopsong();
 			} else {
 				trace("playing "+m);
 				Music.playsong(m);
 			}
		}
	}
	function new(){
		Music.loadsound("blip");
		Music.loadsong("boopy");
		Music.loadsong("house1");
		Music.loadsong("house2");
		Music.loadsong("quirky");

		setStage();
 		for (i in 0...100){
 			noisearray.push(Random.int(0,Gfx.screenwidth) + Gfx.screenwidth*Random.int(0,Gfx.screenheight));
 		}
		#if js
		 {
			Browser.document.oncontextmenu = Browser.document.body.oncontextmenu = function() {return false;}

			Browser.document.addEventListener("click", function( event ) {
				if (this.overLink1>0)
				{
					Browser.window.open("https://www.increpare.com","_blank");
					this.overLink1=0;
				}
				if (this.overLink2>0){
					Browser.window.open("https://www.patreon.com/increpare","_blank");
					this.overLink2=0;
				}
    			// display the current click count inside the clicked div
    			event.target.textContent = "click count: " + event.detail;
  			}, false);
		}
		#end

		Text.font = "pixel";
		Text.size = 1;
	}

}